/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage4/include/control_msg.h,v 1.7 2001/06/03 06:06:45 koni Exp $ 
  $Author: koni $ $Date: 2001/06/03 06:06:45 $ $Name:  $
  $Revision: 1.7 $

*/
   
#ifndef CONTROL_MSG_H
#define CONTROL_MSG_H
#include "sym_cipher.h"
#ifndef WIN32
#include <sys/time.h>
#else
#include "slan_windows.h"
#endif
#define DEFAULT_MSG_SIZE (1024)

/* The control message type is less than CONTROL_MSG_MAX for a reason -- keep
   it that way. */
#define CONTROL_MSG_TYPE (0x10009)
#define CONTROL_MSG_MAX  (0x10024)

#include "slan_session.h"

typedef struct {
  slan_session_t *session_obj;
  int length;
  int allocated_size;
  unsigned char *buf;
  unsigned char *head;
  unsigned char *tail;
} control_msg_t;

control_msg_t *new_control_msg(u_int32_t, u_int32_t, slan_session_t *);
void control_msg_destruct(control_msg_t *);
void msg_append_tlv(control_msg_t *, u_int32_t, int, unsigned char *);
void msg_search_tlv(control_msg_t *, u_int32_t, int *, unsigned char **);
void control_msg_send(control_msg_t *msg);
void control_msg_destruct(control_msg_t *msg);

int control_get_elapsed_time(struct timeval tv);


#endif

