/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage4/include/control_tcp.h,v 1.11 2001/06/13 22:19:52 koni Exp $ 
  $Author: koni $ $Date: 2001/06/13 22:19:52 $ $Name:  $
  $Revision: 1.11 $

*/
   
#ifndef CONTROL_TCP_H
#define CONTROL_TCP_H
#ifndef WIN32
#include <sys/types.h>
#include <sys/socket.h>
#endif

#include "slan_types.h"

#include "control_msg.h"

#define SLAN_TCP_PORT (7777)

enum { DIFFIE_HELLMAN = 0, RSAAUTH, SLAN_IPADDR, SLAN_VERSION, CLIENT_AUTH, 
       IPCONF, KEYCHANGE, KEEPALIVE, SHUTDOWN, MAX_TYPES };

enum { KEEPALIVE_PING = 0, KEEPALIVE_RESPONSE };

enum { KEYCHANGE_REQUEST = 0, KEYCHANGE_READY };

typedef void (*protocol_handler_t)(control_msg_t *msg);

typedef struct {
  protocol_handler_t *handlers;
  int max_subtype;
} control_protocol_t;


SOCKET client_open_socket(unsigned char *server_name, unsigned int *, int);
SOCKET server_open_socket();
SOCKET server_accept(SOCKET fd, struct sockaddr_in *address, socklen_t *addrlen);
//void control_init();
control_msg_t *control_msg_receive(slan_session_t *, int *r_type, 
				   int *r_subtype, int microseconds);


#endif

