/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.  

  This program is free software; you can redistribute it and/or	
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

  $Header: /home/cvsroot/stage4/include/slan_version.h,v 1.8 2001/06/03 06:06:45 koni Exp $ 
  $Author: koni $ $Date: 2001/06/03 06:06:45 $ $Name:  $
  $Revision: 1.8 $

*/
   
#ifndef SLAN_VERSION_H
#define SLAN_VERSION_H
#include "slan_session.h"

#define SLAN_MAJOR_VERSION (0x5)
#define SLAN_MINOR_VERSION (0x0)

/* TODO: Find a protocol number that is not already registered
   (and, perhaps, attempt somehow to register than number) */
#define ETH_P_SLAN (0x7777)

#define SLAN_UDP_PORT (7777)

/* This structure is placed on a packet sent to us by the slan device driver.
   Currently, it is not really needed here. */
typedef struct {
  u_int32_t magic_number;
  u_int16_t our_protocol;
  u_int16_t orig_protocol;
} slan_header_t;

/* Some default knob settings */
/* Lifetime of a session key. After this amount of time, another DH
   keyexchange will occur. */
#define KEY_LIFETIME (3600)

/* Maximum amount of data to encrypt with a single key, specified in number of
   packets. This is to prevent sequence number roll-over and large amounts of
   data encrypted with the same key */
#define SEQUENCE_MAX (0xFFFFFFF)

/* This function sends our version information and expects to receive the
   peer's version infomation. Returns negative if incompatible, otherwise
   returns the difference between minor version numbers. */
int check_version(int);

#endif

