/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
  $Header: /home/cvsroot/stage4/platform/windows/driver/slanmac/slansupport.c,v 1.1 2001/06/05 16:02:13 lucasm Exp $
  $Author: lucasm $ $Date: 2001/06/05 16:02:13 $ $Name:  $
  $Revision: 1.1 $
 
*/

//#include "slan.h"// (no, can't do this.. something is amuck in the headers!)

#define WANTVXDWRAPS

#include <basedef.h>
#include <vmm.h>
#include <debug.h>
#include <vxdwraps.h>
#include <vwin32.h>
#include <winerror.h>

#pragma VxD_LOCKED_CODE_SEG
#pragma VxD_LOCKED_DATA_SEG

#define MEMPAGE PAGE

// how absolutely wonderful of windows to not include PageCheckLinRange
// for some stupid reason

DWORD VXDINLINE MyPageCheckLinRange(DWORD a, DWORD b, DWORD c)
{
   DWORD retv;

   _asm push [c]
   _asm push [b]
   _asm push [a]
   VMMCall(_PageCheckLinRange)
   _asm add esp, 0Ch // oh, I'm responsible for cleaning up. oops.
   _asm mov [retv], eax
   return retv;
}

DWORD LockMemory(DWORD addr, DWORD length)
{
	//DBG_FUNC("LockMemory")
	DWORD numberofpages, numberofcommittedpages;
	DWORD inpageoffset;

	// how far into the page is this memory? (we'll have to add this back later)
	inpageoffset = addr & PAGEMASK;

	// find out how many pages we have in this memory length.
	// annoying.
	// PAGESHIFT is 12, PAGE(x) is defined as x >> PAGESHIFT.
	numberofpages = MEMPAGE((addr + length));
	numberofpages -= MEMPAGE(addr);
	numberofpages += 1;


	numberofcommittedpages = MyPageCheckLinRange(MEMPAGE(addr), numberofpages, 0);

	if(numberofcommittedpages < numberofpages)
	{
	//	DBG_PRINT(("!!! Non-committed pages! error error! %d < %d\n",
	//		numberofcommittedpages, numberofpages););
		return 0;
	}

	/* shut up, you stupid compiler. it does exist. */
#pragma warning (disable:4013)
	addr = _LinPageLock(MEMPAGE(addr), numberofpages, PAGEMAPGLOBAL);
#pragma warning (default:4013)
	if(addr == 0)
	{
	//	DBG_PRINT(("LinPageLock FAILED!\n"););
		return 0;
	}

	// this can remap the pages, but it seems that it is guaranteed
	// to return something where the offset is the same.
	addr += inpageoffset;
	return addr;
}

DWORD UnlockMemory(DWORD address, DWORD length)
{
	//DBG_FUNC("UnlockMemory")
	DWORD numberofpages;
	DWORD ret;

	numberofpages = MEMPAGE((address + length));
	numberofpages -= MEMPAGE(address);
	numberofpages += 1;

#pragma warning (disable:4013)
	ret = _LinPageUnLock(MEMPAGE(address), numberofpages, PAGEMAPGLOBAL);
#pragma warning (default:4013)
	if(ret == 0)
	{
	//	DBG_PRINT(("LinPageUnlock FAILED!\n"););
	}
	return ret;
}
