/*
  Lightlink SLAN -- A Virtual Private Network System
  (c) 2001 Mark Wright (Koni), Lucas Madar, Art Matrix - Lightlink, Inc.
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
  $Header: /home/cvsroot/stage4/platform/windows/slandll/slandll.h,v 1.1 2001/06/05 16:09:16 lucasm Exp $
  $Author: lucasm $ $Date: 2001/06/05 16:09:16 $ $Name:  $
  $Revision: 1.1 $
 
*/

#ifdef SLANDLL_EXPORTS
#define SLANDLL_API __declspec(dllexport)
#else
#define SLANDLL_API __declspec(dllimport)
#endif

struct local_info {
	UINT ip;
	UINT netmask;
	UINT gateway;
	UINT ns1;
	UINT ns2;
	UINT ns3;
	UCHAR dhcpchaddr[16];
};

SLANDLL_API void *load_slan_interface(DWORD *err);
SLANDLL_API BOOL start_slan_interface(void *opaque, HANDLE ehandle);
SLANDLL_API BOOL stop_slan_interface(void *opaque);
SLANDLL_API void close_slan_interface(void *opaque);
SLANDLL_API BOOL read_slan_interface(void *opaque, char *buffer, DWORD *bufferlength, BOOL wait);
SLANDLL_API BOOL write_slan_interface(void *opaque, char *buffer, DWORD bufferlength);
SLANDLL_API BOOL get_slan_packet(void *opaque, char **buffer, DWORD *buflen, char **curbuf, DWORD *curbuflen);
SLANDLL_API BOOL write_slan_packet_ether(void *opaque, char *buf, DWORD bufferlength);
SLANDLL_API BOOL set_slan_info(void *opaque, struct local_info *li);

